<?php

namespace FiloBlu\Newsletter\Block;

use Magento\Newsletter\Model\SubscriberFactory;

class Popup extends \Magento\Framework\View\Element\Template {

    /**
     * Helper
     *
     * @var \FiloBlu\Newsletter\Helper\Data
     */
    public $_helper;
    public $_directoryBlock;
    protected $_storeManager;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $_customerSession;

    public function __construct(
    \Magento\Framework\View\Element\Template\Context $context, array $data = [], \FiloBlu\Newsletter\Helper\Data $helper, \Magento\Directory\Block\Data $directoryBlock, \Magento\Customer\Model\Session $customerSession, SubscriberFactory $subscriberFactory
    ) {
        $this->_helper = $helper;
        $this->_directoryBlock = $directoryBlock;
        $this->_storeManager = $context->getStoreManager();
        $this->_customerSession = $customerSession;
        $this->_subscriberFactory = $subscriberFactory;
        parent::__construct($context, $data);
    }

    public function getCountries() {
        $country = $this->_directoryBlock->getCountryHtmlSelect();
        return $country;
    }

    public function getCustomerInfo() {
        if ($this->_customerSession->isLoggedIn()) {
            return $this->_customerSession->getCustomer();
        } else {
            return false;
        }
    }

    /**
     * Retrieve form action url and set "secure" param to avoid confirm
     * message when we submit form from secure page to unsecure
     *
     * @return string
     */
    public function getFormActionUrl() {
        return $this->getUrl('newsletterajax/subscriber/new', ['_secure' => true]);
    }

    

    public function customerAlreadySubscribed() {
        
        $isSubscribed = false;
        
        if ($this->_customerSession->isLoggedIn()) {
            $email = $this->_customerSession->getCustomerDataObject()->getEmail();

            $subscriber = $this->_subscriberFactory->create()->loadByEmail($email);

            if ($subscriber->getSubscriberStatus() == \Magento\Newsletter\Model\Subscriber::STATUS_SUBSCRIBED) {
                $isSubscribed = true;
            }
        }
        
        return $isSubscribed;
    }

    protected function _toHtml() {

        if (!$this->_helper->getConfig("popup/enabled")) {
            return "";
        } else {
            return parent::_toHtml();
        }
    }

}
